--!parent
--!encoding=utf-8

--****************************************************************************
-- Handles a single keyboard key
--
-- @author Valentin Schmidt
-- @version 0.1
--****************************************************************************

global $

property _sprite
property _color
property _msgOn
property _msgOff
property _rect

----------------------------------------
--
----------------------------------------
on new (me, spriteRef, note, r)
	me._sprite = spriteRef
	me._color = spriteRef.color
	me._msgOn = [#type:#noteOn, #channel:1, #keyNumber:note, #velocity:127]
	me._msgOff = [#type:#noteOff, #channel:1, #keyNumber:note, #velocity:127]
	me._rect = r
	return me
end

----------------------------------------
--
----------------------------------------
on touchStart (me, touchEventID, touchPoint)
	if touchPoint.inside(me._rect) then

		-- dynamics based on y-coordinate
		me._msgOn[#velocity] = 64 + 63 * touchPoint.locV/me._sprite.height
		
		$.midiio.SendMessage(me._msgOn)
		me.color = rgb(255,255,0)
		return me
	end if
end

----------------------------------------
--
----------------------------------------
on touchEnd (me, touchEventID, touchPoint)
	$.midiio.SendMessage(me._msgOff)
	me.color = me._color
end

----------------------------------------
--
----------------------------------------
on touchMove (me, touchEventID, touchPoint)
	if not touchPoint.inside(me._rect) then
		$.midiio.SendMessage(me._msgOff)
		_movie.touchStart(touchEventID, touchPoint)
		me.color = me._color
	end if
end
